#!/bin/bash

# This specifies third-party and extra patches which will be
# automatically applied for any build sequence. Think of these set
# as of your own persistent modifications you want to keep in sync
# with generic nexenta/on tree
EXTRA_PATCHES_DIR=/var/lib/on-patches

# This is local onnv-gate clone root directory
DEST=$1
test "x$DEST" = x && exit 1
test ! -d $DEST/.hg && exit 1

# Command to process: qpush or qpop
CMD=$2
test "x$CMD" = x && exit 1

CURDIR=`pwd`

cd $DEST
test -L .hg/patches || ln -s $CURDIR/debian/patches .hg

if test -e $EXTRA_PATCHES_DIR; then
	for p in `find $EXTRA_PATCHES_DIR/ -name "*.patch"`; do
		pname=$(basename $p)
		if test $CMD = qpush; then
			ln -sf $p .hg/patches
			if ! cat .hg/patches/series | grep $pname; then
				echo $pname >> .hg/patches/series
			fi
		elif test $CMD = qpop; then
			rm -f .hg/patches/$pname
			if cat .hg/patches/series | grep $pname; then
				sed -i -e "/$pname/d" .hg/patches/series
			fi
		fi
	done
fi

hg $CMD -a
