#!/bin/bash

DEST=$1
test "x$DEST" = x && exit 1
test "x$DEST" = x/ && exit 1

GATE=$2
test "x$GATE" = x && exit 1
test "x$GATE" = x/ && exit 1
test ! -d "$GATE/.hg" && exit 1

CURDIR=`pwd`

hg clone -r onnv_104 $GATE $DEST || exit 1

cd $DEST

# Setup our head...
#hg pull -r 2e139ab87d6e
#hg update

# Backout/Merge/Tune head...
hg backout -r c9d1ff3943b8 --merge -m "backout 0.97 GRUB changes 1"
hg commit -m"backout 0.97 GRUB changes 1"

hg backout -r 9e36a0eaf253 --merge -m "backout 0.97 GRUB changes 2"
hg commit -m"backout 0.97 GRUB changes 2"

# XXX: see b103-specific-1.patch
hg backout -r 271f44d3de11 --merge -m "backout 0.97 GRUB changes 3"
hg commit -m"backout 0.97 GRUB changes 3"

hg backout -r b3af80bbf173 --merge -m "backout 0.97 GRUB changes 4"
hg commit -m"backout 0.97 GRUB changes 4"

# Done: print the result...
hg heads

# Apply new closed binaries...
rm -rf closed
tar xjf $CURDIR/debian/on-closed-bins-nd.i386.tar.bz2
cd closed && ln -s root_i386-nd root_i386

# Setup Nexenta patch queue...
rm -f $CURDIR/debian/patches/status
ln -s $CURDIR/debian/patches .hg
